"""
Copyright (c) 2023, Magentix
This code is licensed under simplified BSD license (see LICENSE for details)
"""


def more_posts(data: dict, args: dict) -> str:
    """
    Display the previous and next post
    """
    query = args.get('_stapy').get('json_query')
    posts = query.fetch('SELECT ITEMS WHERE "post" in tags ORDER BY date desc')
    iterator = 0
    post_1 = post_2 = None
    for _key, page in posts:
        if page.get('_full_path') == data.get('_full_path'):
            try:
                if iterator:
                    post_1 = posts[iterator - 1][1].get('_full_path')
                post_2 = posts[iterator + 1][1].get('_full_path')
            except IndexError:
                pass
            break
        iterator = iterator + 1
    content = ''
    if post_1:
        content += f'<div class="post previous">{{% block.article + {post_1} %}}</div>'
    if post_2:
        content += f'<div class="post next">{{% block.article + {post_2} %}}</div>'
    return content
